	/* Define colours for the textbox */
#define DRAGBOX_TEXT_COLOR YELLOW
#define DRAGBOX_BORD_COLOR WHITE
#define DRAGBOX_BACK_COLOR BLACK
#define DRAGBOX_BOLDTEXT_COLOR BLACK
#define DRAGBOX_BOLDBACK_COLOR LIGHTGRAY
#define DRAGBOX_ARROW_TEXT_COLOR BLACK
#define DRAGBOX_ARROW_BACK_COLOR GREEN

	/* Maximum array size in the class DRAG_ARRAY */
#define MAX_DRAG_ARRAY 6

	/* Holds list of all drag-buttons - used to detect which one was clicked */
class DRAG_BUTTON {

public:
  int x, y; 	/* Coordinates of the 'Button' or Arrow */
  boolean active;	/* Are we 'in' the list at the moment */
  char title[21];	/* The displayed title of the list */
  char value[21];	/* The current value of the drag list */
  unsigned long number;          /* The secondary value */
  LIST_BOX far *list;	/* What list-data the button points to */

	/* Class Constructor */
  DRAG_BUTTON (const int x1 = -1, const int y1 = -1, LIST_BOX far *list1 = NULL, const char *string = NULL);

	/* Returns TRUE if a mouse was clicked on drag-button */
  boolean check (const int mx, const int my, const int event);

	/* Main Routine for 'Running' A Drag-List */
  boolean do_draglist (void);

	/* Draws the Drag-List Outine Box */
  void draw_box (void);

	/* Draws the Drag-List Button/Arrow */
  void draw_arrow (void);

	/* Draws the Selected Value...If any */
  void draw_text (void);

	/* Draws the Selected Value Title */
  void draw_title (void);

	/* Finds a Associated Extended Value */
  void find_ext_char (const unsigned char ch);

	/* Finds a Associated Extended Value */
  void find_ext_int (const unsigned int i);

	/* Finds a Associated Extended Value */
  void find_ext_long (const unsigned long l);
 };


	/* Simply an array of Drag Buttons. */
class DRAG_ARRAY {

public:
  DRAG_BUTTON buttons[MAX_DRAG_ARRAY];

	/* Adds a drag button to end of array */
  int add_button (const int x1, const int y1, LIST_BOX far *list1, const char *string);

       /* Adds Button To End of Array */
  int add_button (LIST_BOX far *list1, const char *string);

	/* Checks for a click on a Drag Button and calls appropiate routine */
  boolean check (const int mx, const int my, const int event);

	/* Draws everything */
  void draw_all (void);

	/* Draws all drag button arrows in array */
  void draw_arrows ();

	/* Draws all the Selected Values...If any */
  void draw_texts (void);

	/* Draws the Selected Value Title */
  void draw_titles (void);

	/* Initializes the Values */
  void init_values (void);
 };




	/* Gets a Number from a Dual-Linked List */
unsigned long get_number (DLINKED_LIST far *dllist);