	/* Used In list->check() returns for No-Item Selected */
#define    NO_ITEM -32000
#define SCROLL_BAR -32001

	/* Maximum space between clicks for a double-click */
#define DOUBLE_CLICK_TIME 15

/*===========================================================================
 *			    BEGIN CLASS DEFINITIONS
 *=========================================================================*/
class DLINKED_LIST {

public:
  DLINKED_LIST far *next;
  DLINKED_LIST far *prev;
  char far *data;

  DLINKED_LIST (void);	/* Class Constructor */
  ~DLINKED_LIST (void); /* Class Destructor */

 };


class LIST_BOX {
public:

  int x, y; 		/* Coordinates of box (text mode only) */
  int width, height;    /* Size of box */
  int norm_color; 	/* Colors to print in */
  int norm_bg;
  int high_color;
  int high_bg;
  int current; 		/* Which item in the viewable list are we at? */
  boolean active;  	/* Is this current list-box the active one? */
  DLINKED_LIST far *start, far *list, far *end;	/* List pointers */
  DLINKED_LIST far *view; /* Top item of viewed list */
  SCROLL_TYPE scroll_bar;	/* The scroll bar for the list */

	/* Class Constructor */
  LIST_BOX (const int x1, const int y1, const int w, const int h,
	    const int nc = LIGHTGRAY, const int nb = BLACK, const int hc = BLACK, const int hb = LIGHTGRAY);

	/* Add item to doubly linked list */
  void add_end (const char far *string);
  void add_item (const char far *string, DLINKED_LIST far *dllist = NULL);
  void add_start (const char far *string);
  void add_sort (const char far *string);
  void add_dual_end (const char far *string1, const char far *string2);
  void add_dual_item (const char far *string1, const char far *string2, DLINKED_LIST far *dllist = NULL);
  void add_dual_sort (const char far *string1, const char far *string2);

	/* Has a mouse been 'clicked' in list? */
  int check (const int mx, const int my, const int event);

	/* Deletes an item from the list */
  boolean delete_item (void);

	/* Deletes the entire list */
  void delete_list (void);

	/* Deletes the currently selected item from list */
  boolean delete_select (void);

	/* Draws the List on the Screen...Text Only */
  void draw (void);

	/* Attempts to move the current selected */
  boolean move(int where);

	/* Returns the Name at the current position */
  boolean get_name(char far *string);

	/* Returns the Number of a dual-list at the current position */
  boolean get_number(char far *string);
 };



	/* Gets the Extended Value...If Any */
unsigned char get_ext_char (const DLINKED_LIST far *list);

	/* Gets the Extended Value...If Any */
unsigned int get_ext_int (const DLINKED_LIST far *list);

	/* Gets the Extended Value...If Any */
unsigned long get_ext_long (const DLINKED_LIST far *list);
