	/* For converting the Mouse coor-dinates to screen coordinates */
#define MOUSEX ButtonX/8 + 1
#define MOUSEY ButtonY/8 + 1

	/* Length of Strings */
#define MAX_STRING_LENGTH 81

	/* Color of various things */
#define        TEXT_COLOR LIGHTGREEN
#define      BORDER_COLOR WHITE
#define        BACK_COLOR BLUE
#define       TITLE_COLOR YELLOW
#define    WIN_TEXT_COLOR LIGHTGRAY
#define    WIN_BACK_COLOR BLACK
#define BIGWIN_BORD_COLOR WHITE
#define BIGWIN_TEXT_COLOR BLACK
#define BIGWIN_BACK_COLOR LIGHTGRAY
#define      SHADOW_COLOR BLACK
#define  ERROR_BORD_COLOR LIGHTGRAY
#define  ERROR_TEXT_COLOR WHITE
#define  ERROR_BACK_COLOR RED
#define DIAGWIN_TEXT_COLOR LIGHTGRAY
#define DIAGWIN_BACK_COLOR BLACK
#define DIAGWIN_BOLD_TEXT_COLOR WHITE
#define DIAGWIN_BOLD_BACK_COLOR GREEN


int ctrl_brk_handler (void);

	/* Destorys the Default Button Arrays */
void destroy_buttons (void);

int dos_error_win (const char *msg);
int dos_err_handler (int errval, int ax, int bp, int si);
void draw_textbox (const int x, const int y, const int x1, const int y1,
		   const char *string, const int text_color);

	/* Draws a textbox on the screen with single border */
void draw_sing_textbox (const int x, const int y, const int x1, const int y1, const char *string, const int text_color);

void draw_textbox_center (const int width, const int height, const char *string,
			  const int text_color);

	/* Displays an error message window. Takes same arguments as a printf
	 * statement. */
void error_box (const char *title, const char *msg, ...);

	/* Saves a portion of the screen */
void get_screen (const int x, const int y, const int x1, const int y1, CAPTURE_TEXT *text);
void get_screen (const int width, const int height, CAPTURE_TEXT *text);

	/* Displays and input type box */
boolean get_input (char far *string, const int max_length, const int width, const int height, const char *title, const char *msg, ...);

	/* Displays an Message Dialogue Type box */
void get_message_box (const char *title, const char *msg, ...);

	/* Gets an OK type message from Keybrd/Mouse */
void get_ok_button(const int y);

	/* Gets a Yes/No type Answer from Keyboard/Mouse */
boolean get_yn_choice (const int width, const int height, const char *title, const char *msg);

	/* Displays a Y/N/ESC Dialogue Box */
boolean get_yn_choice(const char *title, const char *msg, ...);

	/* Initializes the Default Button Arrays */
void init_buttons (void);

boolean input_string (char *string, int x, int y, int max_length);

	/* Puts a previously saved portion of the screen */
void put_screen (CAPTURE_TEXT *text);

unsigned char wait_for_key(void);